'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactVirtualized = require('react-virtualized');

var _Action = require('../../Actions/Action/Action.component');

var _Action2 = _interopRequireDefault(_Action);

var _Item = require('./Item/Item.component');

var _Item2 = _interopRequireDefault(_Item);

var _ItemEdit = require('./Item/ItemEdit.component');

var _ItemEdit2 = _interopRequireDefault(_ItemEdit);

var _ItemEdit3 = require('./Item/ItemEdit.propTypes');

var _ItemEdit4 = _interopRequireDefault(_ItemEdit3);

var _Items = require('./Items.scss');

var _Items2 = _interopRequireDefault(_Items);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function listClasses() {
	return (0, _classnames2.default)(_defineProperty({}, _Items2.default['tc-list-items'], true));
}

function itemsClasses() {
	var _classNames2;

	return (0, _classnames2.default)((_classNames2 = {}, _defineProperty(_classNames2, _Items2.default['tc-enumeration-items'], true), _defineProperty(_classNames2, 'tc-enumeration-items', true), _classNames2));
}

function itemContainer() {
	var _classNames3;

	return (0, _classnames2.default)((_classNames3 = {}, _defineProperty(_classNames3, _Items2.default['tc-item-container'], true), _defineProperty(_classNames3, 'tc-item-container', true), _classNames3));
}

var DISPLAY_MODE_EDIT = 'DISPLAY_MODE_EDIT';

function Items(_ref) {
	var items = _ref.items,
	    itemsProp = _ref.itemsProp,
	    currentEdit = _ref.currentEdit,
	    searchCriteria = _ref.searchCriteria;

	function getRowHeight(_ref2) {
		var index = _ref2.index;

		var isEditMode = items[index].displayMode === DISPLAY_MODE_EDIT;
		return itemsProp.getItemHeight(isEditMode);
	}

	function getItem(item, index) {
		// affecting index to the item
		var itemWithIndex = _extends({}, item, {
			index: index
		});

		switch (item.displayMode) {
			case DISPLAY_MODE_EDIT:
				{
					var itemPropsEdit = {
						key: itemsProp.key,
						actions: itemsProp.actionsEdit,
						onSubmitItem: itemsProp.onSubmitItem,
						onAbortItem: itemsProp.onAbortItem,
						onChangeItem: itemsProp.onChangeItem
					};
					itemWithIndex.itemProps = itemPropsEdit;

					return _react2.default.createElement(_ItemEdit2.default, {
						key: index + '-item',
						id: index + '-item',
						item: itemWithIndex,
						currentEdit: currentEdit
					});
				}
			default:
				{
					var itemPropDefault = {
						key: itemsProp.key,
						actions: itemsProp.actionsDefault,
						onSelectItem: itemsProp.onSelectItem
					};
					itemWithIndex.itemProps = itemPropDefault;

					return _react2.default.createElement(_Item2.default, {
						key: index + '-item',
						id: index + '-item',
						item: itemWithIndex,
						itemProps: itemPropDefault,
						searchCriteria: searchCriteria
					});
				}
		}
	}

	function rowRenderer(_ref3) {
		var key = _ref3.key,
		    index = _ref3.index,
		    style = _ref3.style;

		return _react2.default.createElement(
			'div',
			{ className: itemContainer(), key: key, style: style },
			getItem(items[index], index)
		);
	}

	return _react2.default.createElement(
		'ul',
		{ className: itemsClasses() },
		_react2.default.createElement(
			_reactVirtualized.AutoSizer,
			null,
			function (_ref4) {
				var height = _ref4.height,
				    width = _ref4.width;
				return _react2.default.createElement(_reactVirtualized.List, {
					className: listClasses(),
					rowRenderer: rowRenderer,
					width: width,
					height: height,
					rowCount: items.length,
					rowHeight: getRowHeight
				});
			}
		)
	);
}

Items.propTypes = _extends({
	items: _react.PropTypes.arrayOf(_react.PropTypes.shape({
		values: _react.PropTypes.arrayOf(_react.PropTypes.string)
	})),
	searchCriteria: _react.PropTypes.string,
	itemsProp: _react.PropTypes.shape({
		key: _react.PropTypes.string.isRequired,
		getItemHeight: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.func, _react2.default.PropTypes.number]),
		onSubmitItem: _react.PropTypes.func,
		onAbortItem: _react.PropTypes.func,
		onSelectItem: _react.PropTypes.func,
		actionsDefault: _react.PropTypes.arrayOf(_react.PropTypes.shape(_Action2.default.propTypes)),
		actionsEdit: _react.PropTypes.arrayOf(_react.PropTypes.shape(_Action2.default.propTypes))
	}).isRequired
}, _ItemEdit4.default);

exports.default = Items;